package com.ssyf.common.core.util;

import cn.hutool.core.util.IdUtil;

/**
 * 唯一编码短id
 *
 * @author huwei
 * @date 2022/7/20 22:53
 */
public class IdShortUtil {
    /**
     * 基础输出字符
     */
    private static final String[] BASE_CHARS = new String[]{"a", "b", "c", "d", "e", "f",
            "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s",
            "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5",
            "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
            "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V",
            "W", "X", "Y", "Z"};

    /**
     * 8为uuid字符
     *
     * @return
     */
    public static String uuid8() {
        StringBuffer shortBuffer = new StringBuffer();
        String uuid = IdUtil.fastSimpleUUID();
        for (int i = 0; i < 8; i++) {
            String str = uuid.substring(i * 4, i * 4 + 4);
            int x = Integer.parseInt(str, 16);
            shortBuffer.append(BASE_CHARS[x % BASE_CHARS.length]);
        }
        return shortBuffer.toString();
    }

}
